Index: main/waeup.aaue/trunk/src/waeup/aaue/interfaces.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/interfaces.py	(revision 14347)
+++ main/waeup.aaue/trunk/src/waeup/aaue/interfaces.py	(revision 14348)
@@ -159,5 +159,5 @@
 
     gst_text_book_1_fee = schema.Float(
-        title = _(u'Text Book Fee GST101 GST102'),
+        title = _(u'Text Book Fee GST101 and GST102'),
         default = 0.0,
         required = True,
@@ -165,5 +165,5 @@
 
     gst_text_book_2_fee = schema.Float(
-        title = _(u'Text Book Fee GST111 GST112'),
+        title = _(u'Text Book Fee GST111 and GST112'),
         default = 0.0,
         required = True,
@@ -178,4 +178,28 @@
     ent_text_book_4_fee = schema.Float(
         title = _(u'Text Book Fee ENT201'),
+        default = 0.0,
+        required = True,
+        )
+
+    gst_text_book_5_fee = schema.Float(
+        title = _(u'Text Book Fee GST101'),
+        default = 0.0,
+        required = True,
+        )
+
+    gst_text_book_6_fee = schema.Float(
+        title = _(u'Text Book Fee GST102'),
+        default = 0.0,
+        required = True,
+        )
+
+    gst_text_book_7_fee = schema.Float(
+        title = _(u'Text Book Fee GST111'),
+        default = 0.0,
+        required = True,
+        )
+
+    gst_text_book_8_fee = schema.Float(
+        title = _(u'Text Book Fee GST112'),
         default = 0.0,
         required = True,
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/studylevel.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/studylevel.py	(revision 14347)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/studylevel.py	(revision 14348)
@@ -201,9 +201,19 @@
                 not 'gst_registration_3' in paid_cats:
                 return False
-            if course.code in ('GST101', 'GST102') and \
-                not 'gst_text_book_1' in paid_cats:
-                return False
-            if course.code in ('GST111', 'GST112') and \
-                not 'gst_text_book_2' in paid_cats:
+            if course.code == 'GST101'and \
+                not 'gst_text_book_1' in paid_cats and \
+                not 'gst_text_book_5' in paid_cats:
+                return False
+            if course.code == 'GST102'and \
+                not 'gst_text_book_1' in paid_cats and \
+                not 'gst_text_book_6' in paid_cats:
+                return False
+            if course.code == 'GST111'and \
+                not 'gst_text_book_2' in paid_cats and \
+                not 'gst_text_book_7' in paid_cats:
+                return False
+            if course.code == 'GST112'and \
+                not 'gst_text_book_2' in paid_cats and \
+                not 'gst_text_book_8' in paid_cats:
                 return False
             if course.code in ('GST222',) and \
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py	(revision 14347)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py	(revision 14348)
@@ -865,4 +865,5 @@
         configuration_1.gst_registration_1_fee = 3333.0
         configuration_1.gst_text_book_1_fee = 4444.0
+        configuration_1.gst_text_book_5_fee = 2222.0
         self.app['configuration'].addSessionConfiguration(configuration_1)
         course = createObject('waeup.Course')
@@ -907,5 +908,5 @@
             in self.browser.contents)
         self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['gst_text_book_1']
+        self.browser.getControl(name="form.p_category").value = ['gst_text_book_5']
         self.browser.getControl("Create ticket").click()
         self.student['payments'].values()[1].approve()
Index: main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py	(revision 14347)
+++ main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py	(revision 14348)
@@ -49,8 +49,12 @@
         'concessional': 'Concessional Fee',
         'id_card': 'Student ID Card',
-        'gst_text_book_1': 'Text Book Fee GST101 GST102',
-        'gst_text_book_2': 'Text Book Fee GST111 GST112',
+        'gst_text_book_1': 'Text Book Fee GST101 and GST102',
+        'gst_text_book_2': 'Text Book Fee GST111 and GST112',
         'gst_text_book_3': 'Text Book Fee GST222',
         'ent_text_book_4': 'Text Book Fee ENT201',
+        'gst_text_book_5': 'Text Book Fee GST101',
+        'gst_text_book_6': 'Text Book Fee GST102',
+        'gst_text_book_7': 'Text Book Fee GST111',
+        'gst_text_book_8': 'Text Book Fee GST112',
         'gst_registration_1': 'Registration Fee GST101 GST102 GST111 GST112',
         'gst_registration_2': 'Registration Fee GST222',
@@ -79,8 +83,12 @@
         'concessional': 'Concessional Fee',
         #'id_card': 'Student ID Card',
-        'gst_text_book_1': 'Text Book Fee GST101 GST102',
-        'gst_text_book_2': 'Text Book Fee GST111 GST112',
+        'gst_text_book_1': 'Text Book Fee GST101 and GST102',
+        'gst_text_book_2': 'Text Book Fee GST111 and GST112',
         'gst_text_book_3': 'Text Book Fee GST222',
         'ent_text_book_4': 'Text Book Fee ENT201',
+        'gst_text_book_5': 'Text Book Fee GST101',
+        'gst_text_book_6': 'Text Book Fee GST102',
+        'gst_text_book_7': 'Text Book Fee GST111',
+        'gst_text_book_8': 'Text Book Fee GST112',
         'gst_registration_1': 'Registration Fee GST101 GST102 GST111 GST112',
         'gst_registration_2': 'Registration Fee GST222',