Index: main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 14365)
+++ main/waeup.kofa/trunk/src/waeup/kofa/applicants/tests/test_browser.py	(revision 14366)
@@ -1685,6 +1685,6 @@
             '\nmsg: Dear Linda Tree,'
             '\nmsg: '
-            '\nmsg: The candidate with Id app2014_372052 and name John Anthony Tester applied to'
-            '\nmsg: the Sample University to study Unnamed Certificate for the 2014/2015 session.'
+            '\nmsg: The candidate with Id app%s_372052 and name John Anthony Tester applied to'
+            '\nmsg: the Sample University to study Unnamed Certificate for the %s/%s session.'
             '\nmsg: The candidate has listed you as referee. You are thus required to kindly use'
             '\nmsg: the link below to provide your referral remarks on or before'
@@ -1711,6 +1711,6 @@
             '\nmsg: Dear Otis Stone,'
             '\nmsg: '
-            '\nmsg: The candidate with Id app2014_<6-DIGITS> and name John Anthony Tester applied to'
-            '\nmsg: the Sample University to study Unnamed Certificate for the 2014/2015 session.'
+            '\nmsg: The candidate with Id app%s_<6-DIGITS> and name John Anthony Tester applied to'
+            '\nmsg: the Sample University to study Unnamed Certificate for the %s/%s session.'
             '\nmsg: The candidate has listed you as referee. You are thus required to kindly use'
             '\nmsg: the link below to provide your referral remarks on or before'
@@ -1724,5 +1724,7 @@
             '\nmsg: Post Graduate School'
             '\nmsg: Sample University'
-            '\nmsg: ' % (mandate_id_0, mandate_id_1),
+            '\nmsg: '
+            % (session_1, session_1, session_2, mandate_id_0,
+               session_1, session_1, session_2, mandate_id_1,),
             self.get_fake_smtp_output()
             )
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_batching.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_batching.py	(revision 14365)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_batching.py	(revision 14366)
@@ -158,4 +158,6 @@
     '\n')[0].split(',')
 
+curr_year = datetime.datetime.now().year
+
 class StudentImportExportSetup(FunctionalTestCase):
 
@@ -274,5 +276,5 @@
         # get a payment with all fields set
         payment = StudentOnlinePayment()
-        payment.creation_date = datetime.datetime(2012, 4, 1, 13, 12, 1)
+        payment.creation_date = datetime.datetime(curr_year-6, 4, 1, 13, 12, 1)
         payment.p_id = 'my-id'
         payment.p_category = u'schoolfee'
@@ -281,6 +283,6 @@
         payment.p_item = u'p-item'
         payment.p_level = 100
-        payment.p_session = 2012
-        payment.payment_date = datetime.datetime(2012, 4, 1, 14, 12, 1)
+        payment.p_session = curr_year - 6
+        payment.payment_date = datetime.datetime(curr_year-6, 4, 1, 14, 12, 1)
         payment.amount_auth = 12.12
         payment.r_amount_approved = 12.12
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 14365)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_export.py	(revision 14366)
@@ -766,7 +766,8 @@
             'r_code,r_desc,student_id,state,current_session\r\n'
 
-            '666,12.12,2012-04-01 13:12:01#,schoolfee,1,my-id,'
-            'p-item,100,2012,paid,2012-04-01 14:12:01#,12.12,'
+            '666,12.12,%s-04-01 13:12:01#,schoolfee,1,my-id,'
+            'p-item,100,%s,paid,%s-04-01 14:12:01#,12.12,'
             'r-code,,A111111,created,2012\r\n'
+            % (curr_year-6, curr_year-6, curr_year-6)
             )
         return
@@ -785,7 +786,8 @@
             'r_code,r_desc,student_id,state,current_session\r\n'
 
-            '666,12.12,2012-04-01 13:12:01#,schoolfee,1,my-id,'
-            'p-item,100,2012,paid,2012-04-01 14:12:01#,12.12,'
+            '666,12.12,%s-04-01 13:12:01#,schoolfee,1,my-id,'
+            'p-item,100,%s,paid,%s-04-01 14:12:01#,12.12,'
             'r-code,,A111111,created,2012\r\n'
+            % (curr_year-6, curr_year-6, curr_year-6)
             )
         return
@@ -804,7 +806,8 @@
             'r_code,r_desc,student_id,state,current_session\r\n'
 
-            '666,12.12,2012-04-01 13:12:01#,schoolfee,1,my-id,'
-            'p-item,100,2012,paid,2012-04-01 14:12:01#,12.12,'
+            '666,12.12,%s-04-01 13:12:01#,schoolfee,1,my-id,'
+            'p-item,100,%s,paid,%s-04-01 14:12:01#,12.12,'
             'r-code,,A111111,created,2012\r\n'
+            % (curr_year-6, curr_year-6, curr_year-6)
             )
         return
@@ -826,7 +829,8 @@
             'r_code,r_desc,student_id,state,current_session\r\n'
 
-            '666,12.12,2012-04-01 13:12:01#,schoolfee,1,my-id,'
-            'p-item,100,2012,paid,2012-04-01 14:12:01#,12.12,'
+            '666,12.12,%s-04-01 13:12:01#,schoolfee,1,my-id,'
+            'p-item,100,%s,paid,%s-04-01 14:12:01#,12.12,'
             'r-code,,A111111,created,2012\r\n'
+            % (curr_year-6, curr_year-6, curr_year-6)
             )
         return
@@ -854,5 +858,6 @@
             self.app, self.outfile,
             current_session=None, current_level=None,
-            payments_start='01/04/2012', payments_end='01/04/2012')
+            payments_start='01/04/%s' % (curr_year-6),
+            payments_end='01/04/%s' % (curr_year-6))
         result = open(self.outfile, 'rb').read()
         self.assertEqual(
@@ -862,7 +867,8 @@
             'r_code,r_desc,student_id,state,current_session\r\n'
 
-            '666,12.12,2012-04-01 13:12:01#,schoolfee,1,my-id,'
-            'p-item,100,2012,paid,2012-04-01 14:12:01#,12.12,'
+            '666,12.12,%s-04-01 13:12:01#,schoolfee,1,my-id,'
+            'p-item,100,%s,paid,%s-04-01 14:12:01#,12.12,'
             'r-code,,A111111,created,2012\r\n'
+            % (curr_year-6, curr_year-6, curr_year-6)
             )
         # Payment date is 2012-04-01, 14:12:01.
@@ -938,7 +944,8 @@
             'r_code,r_desc,student_id,state,current_session\r\n'
 
-            '666,12.12,2012-04-01 13:12:01#,schoolfee,1,my-id,'
-            'p-item,100,2012,unpaid,2012-04-01 14:12:01#,12.12,'
+            '666,12.12,%s-04-01 13:12:01#,schoolfee,1,my-id,'
+            'p-item,100,%s,unpaid,%s-04-01 14:12:01#,12.12,'
             'r-code,,A111111,created,2012\r\n'
+            % (curr_year-6, curr_year-6, curr_year-6)
             )
         return
@@ -967,7 +974,8 @@
             'state,current_session,entry_session,entry_mode,faccode,depcode,certcode\r\n'
 
-            '666,12.12,2012-04-01 13:12:01#,schoolfee,1,my-id,p-item,100,2012,'
-            'paid,2012-04-01 14:12:01#,12.12,r-code,,A111111,234,123,'
+            '666,12.12,%s-04-01 13:12:01#,schoolfee,1,my-id,p-item,100,%s,'
+            'paid,%s-04-01 14:12:01#,12.12,r-code,,A111111,234,123,'
             'Anna,M.,Tester,created,2012,2010,ug_ft,NA,NA,CERT1\r\n'
+            % (curr_year-6, curr_year-6, curr_year-6)
             )
         return
@@ -1154,5 +1162,5 @@
             'current_level,current_session,current_mode,entry_session,'
             'reg_number,%s\r\nA111111,234,Anna M. Tester,created,CERT1,NA,NA,0,'
-            '200,2012,ug_ft,2010,123,,,,,,14.14,waived,,,,\r\n'
+            '200,2012,ug_ft,2010,123,,,,,12.12,14.14,waived,,,,\r\n'
             % year_range_str in result
             )