Index: main/waeup.kofa/trunk/src/waeup/kofa/students/reports/level_report.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/reports/level_report.py	(revision 14367)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/reports/level_report.py	(revision 14368)
@@ -69,4 +69,5 @@
                 level_obj.gpa_params[1],
                 passed_params[2],
+                passed_params[5],
                 level_obj.gpa,
                 failed_courses,
@@ -116,4 +117,5 @@
             TTR(translate(_('Total Credits Taken'))),
             TTR(translate(_('Total Credits Passed'))),
+            TTR(translate(_('Courses Without Result'))),
             TTR(translate(_('GPA'))),
             translate(_('Courses Failed')),
@@ -127,10 +129,10 @@
         # Underline mandatory (core) courses
         failed_courses = Paragraph(
-            line[5].replace('m_', '<u>').replace('_m', '</u>'), SMALL_PARA_STYLE)
-        line = line[:5] + (failed_courses,) + line[6:]
+            line[6].replace('m_', '<u>').replace('_m', '</u>'), SMALL_PARA_STYLE)
+        line = line[:6] + (failed_courses,) + line[7:]
         # Superscript in remarks (needed by AAUE)
         remark = Paragraph(
-            line[9].replace('s_', '<super>').replace('_s', '</super>'), SMALL_PARA_STYLE)
-        line = line[:9] + (remark,)
+            line[10].replace('s_', '<super>').replace('_s', '</super>'), SMALL_PARA_STYLE)
+        line = line[:10] + (remark,)
         line = (sn,) + line
         table.append(line)
@@ -186,5 +188,5 @@
         table_data = tbl_data_to_table(self.data)
         #col_widths = [3.5*cm] * len(self.data[0])
-        col_widths = [1*cm, 4*cm, 5*cm, 0.8*cm, 0.8*cm, 1*cm,
+        col_widths = [1*cm, 4*cm, 5*cm, 0.8*cm, 0.8*cm, 0.8*cm, 1*cm,
                       6*cm, 0.8*cm, 0.8*cm, 1*cm, 2*cm]
         pdf_data = [Paragraph('<b>%s</b>' % self.creation_dt_string,
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/reports/tests/test_level_report.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/reports/tests/test_level_report.py	(revision 14367)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/reports/tests/test_level_report.py	(revision 14368)
@@ -41,5 +41,5 @@
         result = get_students('fac1', 'dep1', 2010, 100)
         self.assertEqual(result,
-            [(u'1234', u'Bob Tester', 90, 30, 1.667, 'm_Course2_m Course3',
+            [(u'1234', u'Bob Tester', 90, 30, 0, 1.667, 'm_Course2_m Course3',
               90, 30, 1.667, '')])
         return
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/studylevel.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/studylevel.py	(revision 14367)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/studylevel.py	(revision 14368)
@@ -160,4 +160,5 @@
     def passed_params(self):
         """Determine the number and credits of passed and failed courses.
+        Count the number of courses registered but not taken.
         This method is used for level reports.
         """
@@ -166,4 +167,5 @@
         credits_failed = 0
         credits_passed = 0
+        no_courses_not_taken = 0
         for ticket in self.values():
             if ticket.total_score is not None:
@@ -178,5 +180,9 @@
                     passed += 1
                     credits_passed += ticket.credits
-        return passed, failed, credits_passed, credits_failed, courses_failed
+            else:
+                no_courses_not_taken += 1
+        return (passed, failed, credits_passed,
+                credits_failed, courses_failed,
+                no_courses_not_taken)
 
     @property
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 14367)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 14368)
@@ -894,8 +894,8 @@
         self.assertEqual(
             self.student['studycourse']['100'].passed_params,
-            (1, 1, 13, 10, 'COURSE1 '))
+            (1, 1, 13, 10, 'COURSE1 ', 0))
         self.assertEqual(
             self.student['studycourse']['200'].passed_params,
-            (0, 0, 0, 0, ''))
+            (0, 0, 0, 0, '', 1))
         # And also cumulative params can be calculated. Meanwhile we have the
         # following courses: COURSE1 and COURSE2 in level 100 and