Index: main/waeup.aaue/trunk/src/waeup/aaue/students/reports/raw_score_report.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/reports/raw_score_report.py	(revision 14370)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/reports/raw_score_report.py	(revision 14374)
@@ -216,5 +216,5 @@
                 faccode, depcode, session, self.levelcode, course_codes)
 
-    def create_pdf(self):
+    def create_pdf(self, job_id):
         creator = getUtility(IPDFCreator, name='A3landscape')
         table_data = dict()
@@ -223,5 +223,6 @@
                 self.data[level], self.course_codes[level])
         col_widths = [1*cm, 4*cm, 5*cm] + [1*cm] * len(self.course_codes)
-        pdf_data = [Paragraph('<b>%s</b>' % self.creation_dt_string,
+        pdf_data = [Paragraph('<b>%s - Report %s</b>'
+                              % (self.creation_dt_string, job_id),
                               STYLE["Normal"]),
                     Spacer(1, 12),]
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/reports/student_level_statistics.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/reports/student_level_statistics.py	(revision 14370)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/reports/student_level_statistics.py	(revision 14374)
@@ -174,9 +174,10 @@
         self.data = get_student_stats(session, mode, breakdown)
 
-    def create_pdf(self):
+    def create_pdf(self, job_id):
         creator = getUtility(IPDFCreator, name='landscape')
         table_data = tbl_data_to_table(*self.data)
         col_widths = [None,] + [1.8*cm] * (len(self.data[1]) - 1)+ [2.0*cm] + [None,]
-        pdf_data = [Paragraph('<b>%s</b>' % self.creation_dt_string,
+        pdf_data = [Paragraph('<b>%s - Report %s</b>'
+                              % (self.creation_dt_string, job_id),
                               STYLE["Normal"]),
                     Spacer(1, 12),]
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/reports/tests/test_level_report.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/reports/tests/test_level_report.py	(revision 14370)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/reports/tests/test_level_report.py	(revision 14374)
@@ -36,5 +36,5 @@
         self.student['studycourse']['100']['Course1'].ca = 0
         report = CustomLevelReport('fac1', 'dep1', 2010, 100)
-        result = report.create_pdf()
+        result = report.create_pdf('JOB_ID')
         self.assertTrue(result.startswith('%PDF-'))
         path = os.path.join(samples_dir(), 'level_report.pdf')
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/reports/tests/test_raw_score_report.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/reports/tests/test_raw_score_report.py	(revision 14370)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/reports/tests/test_raw_score_report.py	(revision 14374)
@@ -67,5 +67,5 @@
         self.student['studycourse']['200']['Course2'] = ticket
         report = RawScoreReport('fac1', 'dep1', 2011, 200)
-        result = report.create_pdf()
+        result = report.create_pdf('JOB_ID')
         self.assertTrue(result.startswith('%PDF-'))
         path = os.path.join(samples_dir(), 'raw_score_report.pdf')
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/reports/tests/test_student_level_statistics.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/reports/tests/test_student_level_statistics.py	(revision 14370)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/reports/tests/test_student_level_statistics.py	(revision 14374)
@@ -102,5 +102,5 @@
         self.student['studycourse'].current_level = 220
         report = StudentLevelStatisticsReport(2010, 'Undergraduate Full-Time', 'depcode')
-        result = report.create_pdf()
+        result = report.create_pdf('JOB_ID')
         self.assertTrue(result.startswith('%PDF-'))
         path = os.path.join(samples_dir(), 'student_level_statistics.pdf')