Index: main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py	(revision 14384)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py	(revision 14385)
@@ -246,34 +246,53 @@
         if self.context.p_category in ('schoolfee_incl', 'schoolfee_1') \
             and academic_session:
-            welfare_fee = gateway_net_amt(academic_session.welfare_fee)
-            union_fee = gateway_net_amt(academic_session.union_fee)
+            #welfare_fee = gateway_net_amt(academic_session.welfare_fee)
+            #union_fee = gateway_net_amt(academic_session.union_fee)
             if self.context.student.entry_session == 2016 \
                 and self.context.student.entry_mode == 'ug_ft' \
                 and self.context.p_session == 2016:
                 # Add student id card fee to first school fee payment.
-                # Attention: The payment slip does not contain any information
-                # whether the fee was added or not.
-                # We can only draw conclusions from from the student's entry
-                # session whether the fee had been included.
-                id_card_fee = gateway_net_amt(academic_session.id_card_fee)
+
+                ## Attention: The payment slip does not contain any information
+                ## whether the fee was added or not.
+                ## We can only draw conclusions from from the student's entry
+                ## session whether the fee had been included.
+                #id_card_fee = gateway_net_amt(academic_session.id_card_fee)
+                #text += ('School Fee, '
+                #         '%s Naira Student ID Card Fee, '
+                #         '%s Naira Student Union Dues, '
+                #         '%s Naira Student Welfare Assurance Fee and '
+                #         % (id_card_fee, union_fee, welfare_fee))
+
                 text += ('School Fee, '
-                         '%s Naira Student ID Card Fee, '
-                         '%s Naira Student Union Dues, '
-                         '%s Naira Student Welfare Assurance Fee and '
-                         % (id_card_fee, union_fee, welfare_fee))
+                         'Student ID Card Fee, '
+                         'Student Union Dues, '
+                         'Student Welfare Assurance Fee and ')
             else:
+
+                #text += ('School Fee, '
+                #         '%s Naira Student Union Dues, '
+                #         '%s Naira Student Welfare Assurance Fee and '
+                #         % (union_fee, welfare_fee))
+
                 text += ('School Fee, '
-                         '%s Naira Student Union Dues, '
-                         '%s Naira Student Welfare Assurance Fee and '
-                         % (union_fee, welfare_fee))
+                         'Student Union Dues, '
+                         'Student Welfare Assurance Fee and ')
         elif self.context.p_category in (
             'clearance_incl', 'clearance_medical_incl') and academic_session:
-            matric_gown_fee = gateway_net_amt(academic_session.matric_gown_fee)
-            lapel_fee = gateway_net_amt(academic_session.lapel_fee)
+
+            #matric_gown_fee = gateway_net_amt(academic_session.matric_gown_fee)
+            #lapel_fee = gateway_net_amt(academic_session.lapel_fee)
+            #text += ('Acceptance Fee, '
+            #         '%s Naira Matriculation Gown Fee, '
+            #         '%s Naira Lapel/File Fee and '
+            #         % (matric_gown_fee, lapel_fee))
+
             text += ('Acceptance Fee, '
-                     '%s Naira Matriculation Gown Fee, '
-                     '%s Naira Lapel/File Fee and '
-                     % (matric_gown_fee, lapel_fee))
-        return text + '250.0 Naira Transaction Charge.'
+                     'Matriculation Gown Fee, '
+                     'Lapel/File Fee and ')
+
+        #return text + '250.0 Naira Transaction Charge.'
+
+        return text + 'Transaction Charge.'
 
 class CustomStudyLevelDisplayFormPage(StudyLevelDisplayFormPage):