Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/level_report.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/level_report.py	(revision 14391)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/level_report.py	(revision 14392)
@@ -60,4 +60,5 @@
         passed_params = level_obj.passed_params
         failed_courses = textwrap.fill(passed_params[4], 35)
+        not_taken_courses = textwrap.fill(passed_params[5], 17)
         fullname = textwrap.fill(stud.display_fullname, 29)
         # This is a very special column requested by AAUE, Nigeria.
@@ -77,5 +78,5 @@
                 '%.3f' % (int(1000*level_obj.gpa)/1000.0),
                 failed_courses,
-                passed_params[5],
+                not_taken_courses,
                 level_obj.cumulative_params[1],
                 level_obj.cumulative_params[4],
@@ -125,5 +126,5 @@
             TTR(translate(_('GPA'))),
             translate(_('Courses Failed')),
-            TTR(translate(_('Courses w/o Result'))),
+            translate(_('Courses w/o Result')),
             TTR(translate(_('Cum. Credits Taken'))),
             TTR(translate(_('Cum. Credits Passed'))),
@@ -156,4 +157,5 @@
     ('ALIGN', (0,0), (0,-1), 'RIGHT'),
     ('ALIGN', (6,0), (6,-1), 'LEFT'),
+    ('ALIGN', (7,0), (7,-1), 'LEFT'),
     ('INNERGRID', (0,1), (-1,-1), 0.25, colors.black),
     ('BOX', (0,1), (-1,-1), 1, colors.black),
@@ -195,5 +197,5 @@
         #col_widths = [3.5*cm] * len(self.data[0])
         col_widths = [1*cm, 4*cm, 5*cm, 0.8*cm, 0.8*cm, 1*cm,
-                      6*cm, 0.8*cm, 0.8*cm, 0.8*cm, 1*cm, 2*cm]
+                      6*cm, 3*cm, 0.8*cm, 0.8*cm, 1*cm, 2*cm]
         pdf_data = [Paragraph('<b>%s - Report %s</b>'
                               % (self.creation_dt_string, job_id),
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/tests/test_level_report.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/tests/test_level_report.py	(revision 14391)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/reports/tests/test_level_report.py	(revision 14392)
@@ -42,5 +42,5 @@
         self.assertEqual(result,
             [(u'1234', u'Bob Tester', 90, 30, '1.666',
-            'm_Course2_m Course3', 0, 90, 30, '1.666', '')])
+            'm_Course2_m Course3', '', 90, 30, '1.666', '')])
         return
 
@@ -59,7 +59,17 @@
         ticket.credits = 30
         ticket.score = 30
-        ticket.mandatory = False
-        ticket.passmark = 40
         self.student['studycourse']['100']['Course3'] = ticket
+        ticket2 = createObject('waeup.CourseTicket')
+        ticket2.code = 'Course4'
+        ticket2.credits = 30
+        self.student['studycourse']['100']['Course4'] = ticket2
+        ticket3 = createObject('waeup.CourseTicket')
+        ticket3.code = 'Course5'
+        ticket3.credits = 30
+        self.student['studycourse']['100']['Course5'] = ticket3
+        ticket4 = createObject('waeup.CourseTicket')
+        ticket4.code = 'Course5'
+        ticket4.credits = 30
+        self.student['studycourse']['100']['Course6'] = ticket4
         report = LevelReport('fac1', 'dep1', 2010, 100)
         result = report.create_pdf('JOB_ID')
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/studylevel.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/studylevel.py	(revision 14391)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/studylevel.py	(revision 14392)
@@ -164,5 +164,5 @@
         credits_failed = 0
         credits_passed = 0
-        no_courses_not_taken = 0
+        courses_not_taken = ''
         for ticket in self.values():
             if ticket.total_score is not None:
@@ -178,8 +178,8 @@
                     credits_passed += ticket.credits
             else:
-                no_courses_not_taken += 1
+                courses_not_taken += '%s ' % ticket.code
         return (passed, failed, credits_passed,
                 credits_failed, courses_failed,
-                no_courses_not_taken)
+                courses_not_taken)
 
     @property
Index: /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py
===================================================================
--- /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 14391)
+++ /main/waeup.kofa/trunk/src/waeup/kofa/students/tests/test_browser.py	(revision 14392)
@@ -895,8 +895,8 @@
         self.assertEqual(
             self.student['studycourse']['100'].passed_params,
-            (1, 1, 13, 10, 'COURSE1 ', 0))
+            (1, 1, 13, 10, 'COURSE1 ', ''))
         self.assertEqual(
             self.student['studycourse']['200'].passed_params,
-            (0, 0, 0, 0, '', 1))
+            (0, 0, 0, 0, '', 'COURSE1 '))
         # And also cumulative params can be calculated. Meanwhile we have the
         # following courses: COURSE1 and COURSE2 in level 100 and