Index: main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py	(revision 14445)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/browser.py	(revision 14453)
@@ -675,5 +675,19 @@
     """ Page to display course tickets
     """
-    form_fields = grok.AutoFields(ICustomCourseTicket)
+
+    @property
+    def show_results(self):
+        isStudent = getattr(
+            self.request.principal, 'user_type', None) == 'student'
+        if isStudent:
+            return False
+        return True
+
+    @property
+    def form_fields(self):
+        if self.show_results:
+            return grok.AutoFields(ICustomCourseTicket)
+        else:
+            return grok.AutoFields(ICustomCourseTicket).omit('score').omit('ca')
 
 class CustomCourseTicketManageFormPage(CourseTicketManageFormPage):
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/browser_templates/courseticketpage.pt
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/browser_templates/courseticketpage.pt	(revision 14453)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/browser_templates/courseticketpage.pt	(revision 14453)
@@ -0,0 +1,21 @@
+<table class="form-table" i18n:domain="waeup.kofa">
+  <tbody>
+    <tal:widgets content="structure provider:widgets" />
+    <tr tal:condition="view/show_results">
+      <td class="fieldname">
+        <span i18n:translate="">Grade</span>:
+      </td>
+      <td>
+        <span tal:replace="context/grade">C</span>
+      </td>
+    </tr>
+    <tr tal:condition="view/show_results">
+      <td class="fieldname">
+        <span i18n:translate="">Weight</span>:
+      </td>
+      <td>
+        <span tal:replace="context/weight">1</span>
+      </td>
+    </tr>
+  </tbody>
+</table>
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/browser_templates/studylevelpage.pt
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/browser_templates/studylevelpage.pt	(revision 14445)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/browser_templates/studylevelpage.pt	(revision 14453)
@@ -28,7 +28,7 @@
       <th i18n:translate="">Cred.</th>
       <th i18n:translate="">Requ.</th>
-      <th i18n:translate="">Score</th>
-      <th i18n:translate="">CA</th>
-      <th i18n:translate="">Grade</th>
+      <th i18n:translate="" tal:condition="view/show_results" >Score</th>
+      <th i18n:translate="" tal:condition="view/show_results" >CA</th>
+      <th i18n:translate="" tal:condition="view/show_results" >Grade</th>
       <th i18n:translate="">CO</th>
       <th i18n:translate="">Auto</th>
@@ -49,5 +49,5 @@
       <td tal:condition="view/show_results" tal:content="value/ca|nothing">CA</td>
       <td tal:condition="view/show_results" tal:content="value/grade|nothing">GRADE</td>
-      <td tal:condition="view/show_results" tal:content="value/carry_over">CO</td>
+      <td tal:content="value/carry_over">CO</td>
       <td tal:content="value/automatic">AUTO</td>
     </tr>
Index: main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py	(revision 14445)
+++ main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py	(revision 14453)
@@ -833,4 +833,15 @@
         print "Sample PDF pg_course_registration_slip.pdf written to %s" % path
 
+        # Students cant' view scores, cas and grades.
+        self.browser.open(self.student_path + '/studycourse/100')
+        self.assertFalse('Score' in self.browser.contents)
+        self.assertFalse('CA' in self.browser.contents)
+        self.assertFalse('Grade' in self.browser.contents)
+        self.browser.getLink("COURSE1").click()
+        self.browser.open(self.student_path + '/studycourse/100')
+        self.assertFalse('Score' in self.browser.contents)
+        self.assertFalse('CA' in self.browser.contents)
+        self.assertFalse('Grade' in self.browser.contents)
+
     def test_student_2nd_semester_course_registration(self):
         IWorkflowState(self.student).setState('school fee paid')