Index: main/waeup.kofa/trunk/src/waeup/kofa/browser/pdf.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/browser/pdf.py	(revision 14494)
+++ main/waeup.kofa/trunk/src/waeup/kofa/browser/pdf.py	(revision 14495)
@@ -29,5 +29,5 @@
 from reportlab.lib import colors
 from reportlab.lib.units import cm, inch, mm
-from reportlab.lib.pagesizes import A4, landscape, portrait
+from reportlab.lib.pagesizes import A4, A3, landscape, portrait
 from reportlab.lib.styles import getSampleStyleSheet, ParagraphStyle
 from reportlab.pdfgen.canvas import Canvas
@@ -858,4 +858,11 @@
     pagesize = landscape(A4)
 
+class A3LandscapePDFCreator(LandscapePDFCreator):
+    """A utility to help with generating PDF docs in
+    A3 landscape format. No watermark is shown.
+    """
+    grok.name('A3landscape')
+    pagesize = landscape(A3)
+
 def get_qrcode(text, width=60.0):
     """Get a QR Code as Reportlab Flowable (actually a `Drawing`).
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/reports/raw_score_report.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/reports/raw_score_report.py	(revision 14494)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/reports/raw_score_report.py	(revision 14495)
@@ -84,7 +84,6 @@
         for ticket in level_obj.values():
             if ticket.code in course_codes:
-                if not None in (ticket.score, ticket.ca):
-                    scores[ticket.code] = (
-                        ticket.score + ticket.ca, ticket.grade)
+                if ticket.total_score is not None:
+                    scores[ticket.code] = (ticket.total_score, ticket.grade)
                 else:
                     scores[ticket.code] = ('NIL', '')
@@ -120,8 +119,4 @@
         canvas.rotate(25)
         canvas.drawString( 0, -1, self.text)
-
-    #def wrap(self,aW,aH):
-    #    canv = self.canv
-    #    return canv._leading, canv.stringWidth(self.text)
 
 def tbl_data_to_table(data, course_codes):
@@ -176,15 +171,5 @@
 
     note = ""
-
-#    note = """
-#<br /><br /><br /><br />
-#<font size='10'>
-#<strong>Note:</strong> This copy is subject to correction for typographical errors and ratification by the departmental board.
-#</font>
-#"""
-
-    signatures = [
-        translate(_('Head of Department')),
-        translate(_('Dean of Faculty'))]
+    signatures = None
 
     def __init__(self, faccode, depcode, certcode, session, level,
Index: main/waeup.kofa/trunk/src/waeup/kofa/students/reports/tests/test_raw_score_report.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/reports/tests/test_raw_score_report.py	(revision 14494)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/reports/tests/test_raw_score_report.py	(revision 14495)
@@ -7,10 +7,10 @@
 from waeup.kofa.students.tests.test_browser import StudentsFullSetup
 from waeup.kofa.tests.test_async import FunctionalAsyncTestCase
+from waeup.kofa.testing import FunctionalLayer
 from waeup.kofa.browser.tests.test_pdf import samples_dir
-
-from waeup.aaue.students.reports.raw_score_report import (
+from waeup.kofa.students.reports.raw_score_report import (
     get_students, RawScoreReport, IRawScoreReport,
     get_courses)
-from waeup.aaue.testing import FunctionalLayer
+
 
 class RawScoreReportTests(CatalogTestSetup):
@@ -22,4 +22,5 @@
         self.course = createObject('waeup.Course')
         self.course.code = 'Course1'
+        self.course.credits = 25
         self.app['faculties']['fac1']['dep1'].courses.addCourse(
             self.course)
@@ -42,13 +43,12 @@
     def test_get_students(self):
         # we can get a table with one student
-        self.student['studycourse']['100']['Course1'].ca = 0
         course_codes = get_courses('fac1', 'dep1', 'CERT1', 2010, 100)
         result = get_students('fac1', 'dep1', 'CERT1', 2010, 100, course_codes)
         self.assertEqual(result,
-            [(u'1234', u'TESTER, Bob', {'Course1': (70, 'A')})])
-        self.student['studycourse']['100']['Course1'].ca = None
+            [(u'1234', u'Bob Tester', {'Course1': (70, 'A')})])
+        self.student['studycourse']['100']['Course1'].score = None
         result = get_students('fac1', 'dep1', 'CERT1', 2010, 100, course_codes)
         self.assertEqual(result,
-            [(u'1234', u'TESTER, Bob', {'Course1': ('NIL', '')})])
+            [(u'1234', u'Bob Tester', {'Course1': ('NIL', '')})])
         return
 
@@ -56,4 +56,5 @@
         self.course = createObject('waeup.Course')
         self.course.code = 'Course2'
+        self.course.credits = 30
         self.app['faculties']['fac1']['dep1'].courses.addCourse(
             self.course)