Index: /main/waeup.aaue/trunk/src/waeup/aaue/students/studylevel.py
===================================================================
--- /main/waeup.aaue/trunk/src/waeup/aaue/students/studylevel.py	(revision 14500)
+++ /main/waeup.aaue/trunk/src/waeup/aaue/students/studylevel.py	(revision 14501)
@@ -117,15 +117,15 @@
     @property
     def course_registration_forbidden(self):
-        fac_dep_paid = True
-        if self.student.entry_session >= 2016:
-            fac_dep_paid = False
-            for ticket in self.student['payments'].values():
-                if ticket.p_category == 'fac_dep' and \
-                    ticket.p_session == self.level_session and \
-                    ticket.p_state == 'paid':
-                        fac_dep_paid = True
-                        continue
-        if not fac_dep_paid:
-            return _("Please pay faculty and departmental dues first.")
+        #fac_dep_paid = True
+        #if self.student.entry_session >= 2016:
+        #    fac_dep_paid = False
+        #    for ticket in self.student['payments'].values():
+        #        if ticket.p_category == 'fac_dep' and \
+        #            ticket.p_session == self.level_session and \
+        #            ticket.p_state == 'paid':
+        #                fac_dep_paid = True
+        #                continue
+        #if not fac_dep_paid:
+        #    return _("Please pay faculty and departmental dues first.")
         restitution_paid = True
         if self.student.entry_session < 2016 \
Index: /main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py
===================================================================
--- /main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py	(revision 14500)
+++ /main/waeup.aaue/trunk/src/waeup/aaue/students/tests/test_browser.py	(revision 14501)
@@ -947,16 +947,16 @@
         self.browser.getLink("Edit course list").click()
         self.browser.getControl("Register course list").click()
-        self.assertTrue('Please pay faculty and departmental dues first'
-            in self.browser.contents)
-        configuration_1 = createObject('waeup.SessionConfiguration')
-        configuration_1.academic_session = 2016
-        configuration_1.fac_dep_fee = 9999.0
-        self.app['configuration'].addSessionConfiguration(configuration_1)
-        self.browser.open(self.payments_path + '/addop')
-        self.browser.getControl(name="form.p_category").value = ['fac_dep']
-        self.browser.getControl("Create ticket").click()
-        self.student['payments'].values()[0].approveStudentPayment()
-        self.browser.open(self.studycourse_path + '/100/edit')
-        self.browser.getControl("Register course list").click()
+        #self.assertTrue('Please pay faculty and departmental dues first'
+        #    in self.browser.contents)
+        #configuration_1 = createObject('waeup.SessionConfiguration')
+        #configuration_1.academic_session = 2016
+        #configuration_1.fac_dep_fee = 9999.0
+        #self.app['configuration'].addSessionConfiguration(configuration_1)
+        #self.browser.open(self.payments_path + '/addop')
+        #self.browser.getControl(name="form.p_category").value = ['fac_dep']
+        #self.browser.getControl("Create ticket").click()
+        #self.student['payments'].values()[0].approveStudentPayment()
+        #self.browser.open(self.studycourse_path + '/100/edit')
+        #self.browser.getControl("Register course list").click()
         self.assertTrue('Course list has been registered'
             in self.browser.contents)
Index: /main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py
===================================================================
--- /main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py	(revision 14500)
+++ /main/waeup.aaue/trunk/src/waeup/aaue/utils/utils.py	(revision 14501)
@@ -89,5 +89,5 @@
         'gst_registration_2': 'Registration Fee GST222',
         'ent_registration_3': 'Registration Fee ENT201',
-        'fac_dep': 'Faculty and Departmental Dues',
+        #'fac_dep': 'Faculty and Departmental Dues',
         'restitution': 'Restitution Fee',
         }